var cardArray = config['cardArray'];
var version = '3.0.2';
var mem = [];
for(i = 0; i < cardArray.length; i++){
	mem[i] = false;
}

var pos = 0;
var startTime = new Date().getTime();

function startCard(){
	var i;
	for(i = 0; i < cardArray.length; i++){
		cardArray[i].iid = i;
	}
	if(config['shuffle']){
		cardArray.shuffle();
	}
	showCard();
	$('#page_intro').hide();
	$('#page_main').show();
}
function showCard(){
	$("#word-content").html(cardArray[pos][0]);
	$("#explanation-content").html(cardArray[pos][1]);
	$("#word").show();
	$("#back").show();
	$("#initial").hide();
	$("#explanation-content").hide();
	$("#question").show();
	$("#done-checkbox").prop("checked", mem[config.cardArray[pos].iid]);
	$("#number").html((pos+1)+"/"+cardArray.length);
	updateProgress();
}
function updateProgress(){
	$(".progress-bar").css("width", getScore() + "%")
	$(".progress-bar").text(getScore() + "%")
}
function showExplanation(event){
	$("#explanation-content").fadeIn();
	$("#question").fadeOut();
	event.preventDefault();
}
function isAll(){
	return $("#mode_select").val() == "all";
}
var preventDoubleAlert = false;
function nextAction(event){
	if(!isAll() && (isCompleted() || countMemed() == mem.length - 1 && $("#done-checkbox").prop("checked") == false)){
		if(!preventDoubleAlert){
			preventDoubleAlert = true;
			setTimeout(function(){preventDoubleAlert = false}, 100);
			alert("未暗記のカードが残っていません。");
		}
		return;
	}
	do{
		pos++;
		pos = pos % cardArray.length;
		showCard();
	}while(mem[config.cardArray[pos].iid] && !isAll())
	event.preventDefault();
}
function prevAction(event){
	if(!isAll() && (isCompleted() || countMemed() == mem.length - 1 && $("#done-checkbox").prop("checked") == false)){
		if(!preventDoubleAlert){
			preventDoubleAlert = true;
			setTimeout(function(){preventDoubleAlert = false}, 100);
			alert("未暗記のカードが残っていません。");
		}
		return;
	}
	do{
		pos--;
		if(pos < 0)pos += cardArray.length;
		showCard();
	}while(mem[config.cardArray[pos].iid] && !isAll())
	event.preventDefault();
}
function save(event){
	mem[config.cardArray[pos].iid] = $("#done-checkbox").prop("checked");
	updateProgress();
	API.SetValue("cmi.suspend_data", getMemData());
	if(isCompleted()){
		API.SetValue("cmi.core.lesson_status", "passed");
	}else{
		API.SetValue("cmi.core.lesson_status", "completed");
	}
	API.SetValue("cmi.core.score.raw", getScore());
	API.Commit("");
}

function setMemData(str){
	var i;
	for(i = 0; i < str.length; i++){
		if(str[i] == "1"){
			mem[i] = true
		}else{
			mem[i] = false
		}
	}
}
function getMemData(){
	var i, str = '';
	for(i = 0; i < mem.length; i++){
		if(mem[i]){
			str += '1';
		}else{
			str += '0';
		}
	}
	return str;
}
function countMemed(){
	var i, count = 0;
	for(i = 0; i < mem.length; i++){
		if(mem[i]){
			count++;
		}
	}
	return count;
}
function getScore(){
	return String(Math.round(countMemed() * 100 / mem.length));
}
function isCompleted(){
	return countMemed() == mem.length;
}

$(function(){
	$("#right").on("click touchstart", nextAction)
	$("#left").on("click touchstart", prevAction)
	$("#question, #explanation").on("click", showExplanation)
	$("#done-checkbox").on("click", save)

	init_scorm();

	var data = API.GetValue("cmi.suspend_data");
	if(data){
		setMemData(data);
	}
	if(isCompleted()){
		API.SetValue("cmi.core.lesson_status", "passed");
	}else{
		API.SetValue("cmi.core.lesson_status", "completed");
	}
	API.Commit("");
	showCard();
});
$(window).on("unload", function(){
	API.SetValue('cmi.core.session_time', formatTimeIntervalForSCORM12(new Date().getTime() - startTime));
	API.Commit("");
	API.Terminate("");
});
function formatTimeIntervalForSCORM12(diff) {
	var h, m, s;
	s = (diff - diff % 1000) / 1000;
	m = (s - s % 60) / 60;
	h = (m - m % 60) / 60;
	s = s - m * 60;
	m = m - h * 60;
	if (h < 10) {
		h = '0' + h;
	}
	if (m < 10) {
		m = '0' + m;
	}
	if (s < 10) {
		s = '0' + s;
	}
	return h + ':' + m + ':' + s;
}

var scorm = 'auto';

function init_scorm() {
	var win1,
		win2;
	try {
		win1 = window;
		try{
			while (win1.API  == null && win1.parent != null && win1.parent != win1) {
				win1 = win1.parent;
			}
		}catch(e){
			console.log("e12");
		}
		win2 = window;
		try{
			while (win2.API_1484_11 == null && win2.parent != null && win2.parent != win2) {
				win2 = win2.parent;
			}
		}catch(e){
			console.log("e2004");
		}
		if ((scorm === 'auto' || scorm === '1.2') && win1.API !== undefined) {
			API = new WrapperAPI_12to2004(win1.API);
			scorm = '1.2';
			console.log("SCORM 1.2 API found");
		} else if ((scorm === 'auto' || scorm === '2004') && win2.API_1484_11 !== undefined) {
			API = win2.API_1484_11;
			scorm = '2004';
			console.log("SCORM 2004 API found");
		} else {
			throw "No API Found";
		}
	} catch (e) {//No API Found or Cross Domain Exception(Firefox and Opera)
		API = new DummyAPI();
		scorm = 'dummy';
		console.log("SCORM API not found. DummyAPI loaded.");
	}
	API.Initialize("");
	try{
		load_suspend_data();
	}catch(e){
		console.log("Failed to load suspend data");
	}
}

var API, startTime;
function DummyAPI() {
	this.Initialize	 = function () {console.log("Initialize"); };
	this.Terminate		 = function () {console.log("Terminate"); };
	this.Commit		 = function () {console.log("Commit"); };
	this.SetValue		= function (key, value) {
		console.log("SetValue(" + key + ", " + value + ")");
		if (key === 'cmi.suspend_data') {
			storeCookie(key, value);
		}
	};
	this.GetValue = function (key) {
		console.log("GetValue(" + key + ")");
		if (key === 'cmi.suspend_data') {
			return loadCookie(key);
		}
	};
}
function WrapperAPI_12to2004(api12) {
	this.Initialize = function (str) {
		return api12.LMSInitialize(str);
	};
	this.Terminate = function (str) {
		return api12.LMSFinish(str);
	};
	this.Commit = function (str) {
		return api12.LMSCommit(str);
	};
	this.SetValue = function (key, value) {
		return api12.LMSSetValue(key, value);
	};
	this.GetValue = function (key) {
		return api12.LMSGetValue(key);
	};
	this.GetLastError = function () {
		return api12.LMSGetLastError("");
	};
}
function storeCookie(cookie_name, value) {
	var ex = new Date();
	ex.setHours(ex.getHours() + 24 * 365);
	ex = ex.toGMTString();
	document.cookie = escape(cookie_name) + "=" + escape(value) + ";expires=" + ex;
}
function loadCookie(loadValue) {
	if (loadValue) {
		var c_data = unescape(document.cookie + ";"),
			n_point = c_data.indexOf(loadValue),
			v_point = c_data.indexOf("=", n_point) + 1,
			end_point = c_data.indexOf(";", n_point);
		if (n_point > -1) {
			c_data = c_data.substring(v_point, end_point);
			return c_data;
		}
		return "";
	}
}
Array.prototype.shuffle = function () {
	'use strict';
	var i = this.length,
		j,
		t;
	while (i) {
		j = Math.floor(Math.random() * i);
		t = this[--i];
		this[i] = this[j];
		this[j] = t;
	}
	return this;
};
